Prime Path POJ

来源:互联网 发布:智能电网通信网络 编辑:程序博客网 时间:2024/05/19 04:55
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
31033 81791373 80171033 1033
Sample Output
67

0

代码:

#include <iostream>#include<stdio.h>#include<cstdio>#include<iostream>#include<algorithm>#include<math.h>#include<string.h>#include<map>#include<queue>#include<vector>#include<deque>#define ll long long#define inf 0x3f3f3f3f#define mem(a,b) memset(a,b,sizeof(a))using namespace std;int prim1[10001],vis[10001],d[1001];struct node{    int x,t;};int prim(int n){    for(int i=2; i*i<=n; i++)    {        if(n%i==0)return 0;    }    return 1;}void init(){    for(int i=1000; i<10000; i++)    {        if(prim(i))prim1[i]=1;    }}int bfs(int aa,int b){    mem(vis,0);    queue<node>p;    while(!p.empty())        p.pop();    vis[aa]=1;    p.push(node{aa,0});    while(!p.empty())    {        node a=p.front();        p.pop();        if(a.x==b)        {            return a.t;        }        for(int i=0; i<4; i++)        {            d[0]=a.x/1000;            d[1]=a.x%1000/100;            d[2]=a.x%100/10;            d[3]=a.x%10;            //int temp=d[i];            for(int j=0; j<=9; j++)            {                if(i==0&&j==0)                    continue;                if(d[i]==j)continue;                d[i]=j;                int sum=d[0]*1000+d[1]*100+d[2]*10+d[3];                //printf("&%d\n",sum);                //printf("#%d %d %d\n",sum,prim1[sum],vis[sum]);                if(prim1[sum]==1&&vis[sum]==0)                {                    p.push(node{sum,a.t+1});                    vis[sum]=1;                }            }            //d[i]=temp;        }    }    return -1;}int main(){    int t;    scanf("%d",&t);    init();    while(t--)    {        int a,b;        scanf("%d%d",&a,&b);        int ans=bfs(a,b);        if(ans==-1)            printf("Impossible\n");        else            printf("%d\n",ans);    }}


0 0
原创粉丝点击